package com.rjconsultores.ventaboletos.relatorios.impl;

import java.sql.Connection;
import java.sql.ResultSet;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.rjconsultores.ventaboletos.relatorios.utilitarios.DataSource;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.RelatorioGratuidadeBean;
import com.rjconsultores.ventaboletos.web.utilerias.NamedParameterStatement;

import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

public class RelatorioGratuidade extends Relatorio {
	
	private Integer orgaoConcedenteId;

	private List<RelatorioGratuidadeBean> lsDadosRelatorio;
	
	public RelatorioGratuidade(Map<String, Object> parametros, Connection conexao)  throws Exception {
		super(parametros, conexao);
		
		this.setCustomDataSource(new DataSource(this) {
			@Override
			public void initDados() throws Exception {

				Connection conexao = this.relatorio.getConexao();

				Map<String, Object> parametros = this.relatorio.getParametros();

				String fecInicioViagem = null;
				if (parametros.get("fecInicioViagem") != null) {
					fecInicioViagem = parametros.get("fecInicioViagem").toString() + " 00:00:00";
				}
				String fecFinalViagem = null;
				if (parametros.get("fecFinalViagem") != null) {
					fecFinalViagem = parametros.get("fecFinalViagem").toString() + " 23:59:59";
				}
				String fecInicioVenda = null;
				if (parametros.get("fecInicioVenda") != null) {
					fecInicioVenda = parametros.get("fecInicioVenda").toString() + " 00:00:00";
				}
				String fecFinalVenda = null;
				if (parametros.get("fecFinalVenda") != null) {
					fecFinalVenda = parametros.get("fecFinalVenda").toString() + " 23:59:59";
				}
				String empresa = parametros.get("empresa") != null ? parametros.get("empresa").toString() : "";
				String agencia = parametros.get("agencia") != null ? parametros.get("agencia").toString() : "";
				String ruta = parametros.get("ruta") != null && !parametros.get("ruta").equals(-1) ? parametros.get("ruta").toString() : "";
				String origem = parametros.get("origem") != null ? parametros.get("origem").toString() : "";
				String destino = parametros.get("destino") != null ? parametros.get("destino").toString() : "";
				String categoria = parametros.get("categoria") != null ? parametros.get("categoria").toString() : "";
				orgaoConcedenteId = parametros.get("orgao_concedente_id") != null ? (Integer) parametros.get("orgao_concedente_id") : null;
				
				
						
				String sql = getSql(empresa, agencia, ruta, fecInicioViagem, fecFinalViagem, fecInicioVenda, fecFinalVenda, origem, destino, categoria);
				
				SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy hh:mm:ss");
				NamedParameterStatement stmt = new NamedParameterStatement(conexao, sql);
				if (fecInicioViagem != null) {
					stmt.setTimestamp("fecInicioViagem", new java.sql.Timestamp(sdf.parse(fecInicioViagem).getTime()));
				}
				if (fecFinalViagem != null) {
					stmt.setTimestamp("fecFinalViagem", new java.sql.Timestamp(sdf.parse(fecFinalViagem).getTime()));
				}
				if (fecInicioVenda != null) {
					stmt.setTimestamp("fecInicioVenda", new java.sql.Timestamp(sdf.parse(fecInicioVenda).getTime()));
				}
				if (fecFinalVenda != null) {
					stmt.setTimestamp("fecFinalVenda", new java.sql.Timestamp(sdf.parse(fecFinalVenda).getTime()));
				}
				if(empresa != null && !empresa.equals("")){
					stmt.setInt("empresa_id", Integer.parseInt(empresa));
				}
				if(agencia != null && !agencia.equals("")){
					stmt.setInt("puntoventa_id", Integer.parseInt(agencia));
				}
				if(ruta != null && !ruta.equals("")){
					stmt.setInt("ruta_id", Integer.parseInt(ruta));
				}
				if(origem != null && !origem.equals("")){
					stmt.setInt("origem_id", Integer.parseInt(origem));
				}
				if(destino != null && !destino.equals("")){
					stmt.setInt("destino_id", Integer.parseInt(destino));
				}
				if(orgaoConcedenteId != null){
					stmt.setInt("orgao_concedente_id", orgaoConcedenteId);
				}
				
				ResultSet rset = null;
		
				rset = stmt.executeQuery();
		
				lsDadosRelatorio = new ArrayList<RelatorioGratuidadeBean>();
				
				SimpleDateFormat hora = new SimpleDateFormat("HH:mm");
				SimpleDateFormat data = new SimpleDateFormat("dd/MM/yyyy");
				
				while (rset.next()) {
					RelatorioGratuidadeBean gratuidadeBean = new RelatorioGratuidadeBean();
					
					gratuidadeBean.setTarifa(rset.getBigDecimal("precio"));
					gratuidadeBean.setCcf(rset.getString("ccf"));
					gratuidadeBean.setCorridaId(rset.getString("corrida_id"));
					gratuidadeBean.setCveusuario(rset.getString("cveusuario"));
					gratuidadeBean.setDescnumdoc(rset.getString("descnumdoc"));
					gratuidadeBean.setDesctipoventa(rset.getString("desctipoventa"));
					gratuidadeBean.setDestino(rset.getString("destino"));
					gratuidadeBean.setFeccreacion(rset.getDate("feccreacion"));
					gratuidadeBean.setFecdatviaje(rset.getTimestamp("fechorviaje") != null ? data.format(rset.getTimestamp("fechorviaje")) : "");
					gratuidadeBean.setFechorviaje(rset.getTimestamp("fechorviaje") != null ? hora.format(rset.getTimestamp("fechorviaje")) : "");
					gratuidadeBean.setKm(rset.getInt("numkmviaje"));
					gratuidadeBean.setLinha(rset.getString("descruta"));
					gratuidadeBean.setNombpasajero(rset.getString("nombpasajero"));
					gratuidadeBean.setNombpuntoventa(rset.getString("nombpuntoventa"));
					gratuidadeBean.setOrigen(rset.getString("origen"));
					gratuidadeBean.setPorccategoria(rset.getBigDecimal("porccategoria"));
					gratuidadeBean.setPreciooriginal(rset.getBigDecimal("preciooriginal"));
					gratuidadeBean.setPreciopagado(rset.getBigDecimal("preciopagado"));
					gratuidadeBean.setNombempresa(rset.getString("nombempresa"));
					gratuidadeBean.setCvecategoria(rset.getString("cvecategoria"));
					gratuidadeBean.setNumasiento(rset.getString("numasiento"));
					gratuidadeBean.setDescorigen(rset.getString("descorigen"));
					gratuidadeBean.setDescdestino(rset.getString("descdestino"));
					gratuidadeBean.setNumfoliosistema(rset.getString("numfoliosistema"));

					gratuidadeBean.setTipoDoc(rset.getString("desctipodoc"));
					gratuidadeBean.setTipo(rset.getString("desccategoria"));
					gratuidadeBean.setSeguro(rset.getBigDecimal("importeseguro"));
					gratuidadeBean.setPedagio(rset.getBigDecimal("importepedagio"));
					gratuidadeBean.setUtr(rset.getBigDecimal("importetaxaembarque"));
					gratuidadeBean.setRg(rset.getString("DESCNUMDOC"));
					gratuidadeBean.setStatus(rset.getString("INDSTATUSBOLETO"));
					gratuidadeBean.setCodOrigem(rset.getString("codOrigem"));
					gratuidadeBean.setCodDestino(rset.getString("codDestino"));
					gratuidadeBean.setDescorgao(rset.getString("descorgao"));

					lsDadosRelatorio.add(gratuidadeBean);
				}

				if (lsDadosRelatorio.size() > 0) {
					setLsDadosRelatorio(lsDadosRelatorio);
				}
			}
		});
	}
	
	public void setLsDadosRelatorio(List<RelatorioGratuidadeBean> lsDadosRelatorio) {
		this.setCollectionDataSource(new JRBeanCollectionDataSource(lsDadosRelatorio));
		this.lsDadosRelatorio = lsDadosRelatorio;
	}

	@Override
	protected void processaParametros() throws Exception {
	}
	
	private String getSql(String empresa, String agencia, String ruta, String fecInicioViagem, String fecFinalViagem, String fecInicioVenda, String fecFinalVenda, String origem, String destino, String categoria) {
		
		
		StringBuilder sb = new StringBuilder();
	

		sb.append("SELECT * ");
		sb.append("FROM ");
		sb.append("  (SELECT b.boletooriginal_id, b.boleto_id,");
		sb.append("          b.ccf,");
		sb.append("          og.descorgao,");
		sb.append("          b.feccreacion,");
		sb.append("          ori.cveparada origen,");
		sb.append("          des.cveparada destino,");
		sb.append("          ori.descparada descorigen,");
		sb.append("          des.descparada descdestino,");
		sb.append("          b.numkmviaje,");
		sb.append("          r.descruta,");
		sb.append("          b.corrida_id,");
		sb.append("          b.fechorviaje,");
		sb.append("          b.numasiento,");
		sb.append("          b.numfoliosistema,");
		sb.append("          case when b.tipoventa_id in(5,12,18,41,49)  then 'PTA' else tv.desctipoventa end as desctipoventa, ");
		sb.append("          b.nombpasajero,");
		sb.append("          b.descnumdoc,");
		sb.append("          tar.preciooriginal,");
		sb.append("          tar.precio,");
		sb.append("          case when b.PRECIOBASE > 0 then TRUNC(((100 - (b.PRECIOPAGADO * 100) / b.PRECIOBASE)),2) else 0 end as porccategoria, ");
		sb.append("	 	     (select sum(bfpv.importe) from boleto_formapago bfpv where bfpv.boleto_id = b.boleto_id and bfpv.activo = 1) as preciopagado, ");;
		sb.append("          u.cveusuario,");
		sb.append("          ag.nombpuntoventa,");
		sb.append("          e.nombempresa,");
		sb.append("          ca.cvecategoria,");
		sb.append("          b.desctipodoc,");
		sb.append("          ca.desccategoria,");
		sb.append("          b.importepedagio,");
		sb.append("          b.importeseguro,");
		sb.append("          b.importetaxaembarque, ");
		sb.append(" 						case ");
		sb.append(" 					    when b.motivocancelacion_id = 11 ");
		sb.append(" 					         and b.indcancelacion = 0 then 'RESERVA' ");
		sb.append(" 					    when b.motivocancelacion_id = 9 then 'CONFIRMA RESERVA' ");
		sb.append(" 					    when b.motivocancelacion_id = 11 ");
		sb.append(" 					         and b.indcancelacion = 1 then 'LIBERA.RESERVA' ");
		sb.append(" 					    when b.motivocancelacion_id = 12 then 'LIBERA.RESERVA AUTO' ");
		sb.append(" 					    else b.indstatusboleto ");
		sb.append(" 					end as indstatusboleto, ");
		sb.append("          ori.cveparada codorigem,");
		sb.append("          des.cveparada coddestino");
		sb.append("   FROM boleto b");
		sb.append("   JOIN categoria ca ON b.categoria_id = ca.categoria_id");
		sb.append("   JOIN parada ori ON ori.parada_id = b.origen_id");
		sb.append("   JOIN parada des ON des.parada_id = b.destino_id");
		sb.append("   JOIN ruta r ON r.ruta_id = b.ruta_id");
		sb.append("   JOIN tipo_venta tv ON tv.tipoventa_id = b.tipoventa_id");
		sb.append("   JOIN punto_venta ag ON ag.puntoventa_id = b.puntoventa_id");
		sb.append("   JOIN usuario u ON u.usuario_id = b.usuario_id");
		sb.append("   JOIN vigencia_tarifa vt ON b.fechorventa BETWEEN vt.feciniciovigencia AND vt.fecfinvigencia and vt.activo = 1");
		sb.append("   JOIN tarifa tar ON (tar.ruta_id = b.ruta_id");
		sb.append("                       AND tar.marca_id = b.marca_id");
		sb.append("                       AND tar.claseservicio_id = b.claseservicio_id");
		sb.append("                       AND tar.vigenciatarifa_id = vt.vigenciatarifa_id");
		sb.append("                       AND tar.origen_id = b.origen_id");
		sb.append("                       AND tar.destino_id = b.destino_id and tar.activo = 1)");
		sb.append("   JOIN empresa e ON e.empresa_id = b.empresacorrida_id");
		sb.append("   JOIN orgao_concedente og ON og.orgaoconcedente_id = tar.orgaoconcedente_id");
		sb.append("   WHERE 1=1  and b.tipoventa_id = 15");
		sb.append("   AND b.indstatusboleto = 'S' ");
		if (fecInicioViagem != null && fecFinalViagem != null) {
			sb.append(" AND b.feccorrida BETWEEN :fecInicioViagem AND :fecFinalViagem ");
		}
		if (fecInicioVenda != null && fecFinalVenda != null) {
			sb.append(" AND b.fechorventa BETWEEN :fecInicioVenda AND :fecFinalVenda ");
		}
		if (!empresa.isEmpty()){
			sb.append("AND b.empresacorrida_id = :empresa_id  ");
		}
		if (!agencia.isEmpty() && !agencia.equals("-1")){
			sb.append("       AND b.puntoventa_id = :puntoventa_id  ");
		}
		if (!ruta.isEmpty() && !ruta.equals("-1")){
			sb.append("       AND b.ruta_id = :ruta_id  ");
		}
		if(!origem.isEmpty()){
			sb.append("       AND ori.parada_id = :origem_id   ");
		}
		if(!destino.isEmpty()){
			sb.append("       AND des.parada_id = :destino_id   ");
		}
		if(!categoria.isEmpty()){
			sb.append("       AND ca.categoria_id in ("+ categoria +") ");
		}
		if(orgaoConcedenteId != null){
			sb.append("       AND r.orgaoconcedente_id = :orgao_concedente_id  ");
		}
		sb.append("   ");
		sb.append("   UNION ALL ");
		sb.append("   ");
		sb.append("   SELECT c.transacaooriginal_id, c.transacao_id,");
		sb.append("                    c.ccf,");
		sb.append("                    og.descorgao,");
		sb.append("                    c.feccreacion,");
		sb.append("                    ori.cveparada origen,");
		sb.append("                    des.cveparada destino,");
		sb.append("                    ori.descparada descorigen,");
		sb.append("                    des.descparada descdestino,");
		sb.append("                    c.numkmviaje,");
		sb.append("                    r.descruta,");
		sb.append("                    c.corrida_id,");
		sb.append("                    c.fechorviaje,");
		sb.append("                    c.numasiento,");
		sb.append("                    c.numfoliosistema,");
		sb.append("                    case when c.tipoventa_id in(5,12,18,41,49)  then 'PTA' when c.tipoventa_id = '81' then 'VENDA DE TRANSFERENCIA'  when c.tipoventa_id = '82' then 'CONFIRM.VEND.ABERTO'  when c.tipoventa_id = '8' then 'TROCA' else tv.desctipoventa end as desctipoventa, ");
		sb.append("                    c.nombpasajero,");
		sb.append("                    c.descnumdoc,");
		sb.append("                    tar.preciooriginal,");
		sb.append("                    tar.precio,");
		sb.append("         		  case when c.PRECIOBASE > 0 then TRUNC(((100 - (c.PRECIOPAGADO * 100) / c.PRECIOBASE)),2) else 0 end as  porccategoria, ");
		sb.append("	 			      (select sum(cfpv.importe) from caja_formapago cfpv where cfpv.caja_id = c.caja_id and cfpv.activo = 1) as preciopagado, ");
		sb.append("                    u.cveusuario,");
		sb.append("                    ag.nombpuntoventa,");
		sb.append("                    e.nombempresa,");
		sb.append("                    ca.cvecategoria,");
		sb.append("                    c.desctipodoc,");
		sb.append("                    ca.desccategoria,");
		sb.append("                    c.importepedagio,");
		sb.append("                    c.importeseguro,");
		sb.append("                    c.importetaxaembarque,");
		sb.append("                    case when c.indstatusboleto = 'V' then 'VENDIDO' when c.indstatusboleto = 'C' and c.motivocancelacion_id = 31 then 'CANCELADO' ");
		sb.append(" 				        when c.indstatusboleto = 'C' and c.motivocancelacion_id = 32 then 'DEVOLVIDO' ");
		sb.append(" 				        when c.indstatusboleto = 'C' and c.motivocancelacion_id = 37 then 'CANCEC. EMERG' ");
		sb.append(" 				        when c.indstatusboleto = 'E' and c.indreimpresion = 1 then  'ENTREGUE' ");
		sb.append("                         when c.indstatusboleto = 'T' and c.motivocancelacion_id = 10 or c.tipoventa_id = 8  then 'TROCA'  ");
		sb.append("                         when c.indstatusboleto = 'T'  and c.tipoventa_id = 81 or c.tipoventa_id = 81 then 'TRANSFERNCIA' " );
		sb.append("                         when c.indstatusboleto = 'T'  and c.tipoventa_id = 82 then 'CONFIRM.ABERTO' " );
		sb.append("                         when c.indstatusboleto = 'C'  and c.motivocancelacion_id = 10 then 'TROCA PASSAGEM' " );
		sb.append("                         when c.indstatusboleto = 'T' and c.tipoventa_id = 41  then 'CHECKIN REATIVADO' end as indstatusboleto, ");
		sb.append("                    ori.cveparada codorigem,");
		sb.append("                    des.cveparada coddestino");
		sb.append("   FROM caja c");
		sb.append("   JOIN categoria ca ON c.categoria_id = ca.categoria_id");
		sb.append("   JOIN parada ori ON ori.parada_id = c.origen_id");
		sb.append("   JOIN parada des ON des.parada_id = c.destino_id");
		sb.append("   JOIN ruta r ON r.ruta_id = c.ruta_id");
		sb.append("   JOIN tipo_venta tv ON tv.tipoventa_id = c.tipoventa_id");
		sb.append("   JOIN punto_venta ag ON ag.puntoventa_id = c.puntoventa_id");
		sb.append("   JOIN usuario u ON u.usuario_id = c.usuario_id");
		sb.append("   JOIN vigencia_tarifa vt ON c.fechorventa BETWEEN vt.feciniciovigencia AND vt.fecfinvigencia");
		sb.append("   JOIN tarifa tar ON (tar.ruta_id = c.ruta_id");
		sb.append("                       AND tar.marca_id = c.marca_id");
		sb.append("                       AND tar.claseservicio_id = c.claseservicio_id");
		sb.append("                       AND tar.vigenciatarifa_id = vt.vigenciatarifa_id");
		sb.append("                       AND tar.origen_id = c.origen_id");
		sb.append("                       AND tar.destino_id = c.destino_id and tar.activo = 1)");
		sb.append("   JOIN empresa e ON e.empresa_id = c.empresacorrida_id");
		sb.append("   JOIN orgao_concedente og ON og.orgaoconcedente_id = tar.orgaoconcedente_id");
		sb.append("   WHERE 1=1  and (c.motivocancelacion_id IN (31,32,37,10) OR c.motivocancelacion_id IS NULL) ");
		sb.append("     AND (c.indreimpresion = 0  OR (c.indstatusboleto IN ('E','T') AND c.indreimpresion = 1))");
		if (fecInicioViagem != null && fecFinalViagem != null) {
			sb.append(" AND c.feccorrida BETWEEN :fecInicioViagem AND :fecFinalViagem ");
		}
		if (fecInicioVenda != null && fecFinalVenda != null) {
			sb.append(" AND c.fechorventa BETWEEN :fecInicioVenda AND :fecFinalVenda ");
		}
		if (!empresa.isEmpty()){
			sb.append("AND c.empresacorrida_id = :empresa_id  ");
		}
		if (!agencia.isEmpty() && !agencia.equals("-1")){
			sb.append("AND c.puntoventa_id = :puntoventa_id  ");
		}
		if (!ruta.isEmpty() && !ruta.equals("-1")){
			sb.append("AND c.ruta_id = :ruta_id  ");
		}
		if(!origem.isEmpty()){
			sb.append("AND ori.parada_id = :origem_id   ");
		}
		if(!destino.isEmpty()){
			sb.append("AND des.parada_id = :destino_id   ");
		}
		if(!categoria.isEmpty()){
			sb.append("AND ca.categoria_id in ("+ categoria +") ");
		}
		if(orgaoConcedenteId != null){
			sb.append("AND r.orgaoconcedente_id = :orgao_concedente_id  ");
		}
		sb.append(") ");
		sb.append("ORDER BY 5,15");

		return sb.toString();
	}
}